View Issue Details

IDProjectCategoryView StatusLast Update
0013227mantisbtdb oraclepublic2015-03-16 19:27
ReporterDKuranovAssigned Todregad 
PrioritynormalSeverityblockReproducibilityalways
Status closedResolutionfixed 
PlatformAllOSAllOS Version
Product Version1.2.6 
Target Version1.3.0-beta.1Fixed in Version1.3.0-beta.1 
Summary0013227: Oracle DB support multiple issues
Description

Mantis 1.2.6 cannot work now with Oracle DB:

  1. Installation:
    1.1. Oracle DB autocreates PK, so index creation for same field forbidden
    1.2. Oracle DB uses datetime literal format timestamp'YYYY-MM-DD HH-MI:SS'
    1.3. Oracle DB don't allows altering field property NOT NULL into NOT NULL
    1.4. Oracle DB max object length is 30 chars, so some index names must be reduced
    1.5. Oracle DB means empty string as NULLs, so NOT NULL restriction must be disabled for some field
    1.6. Oracle DB can resolve database server name through TNS, so database name cannot be required
  2. General:
    1.2. Direct DB query execution result accessing instead of db_fetch_array() 1.3. usage didn't works with Oracle DB
    1.4. Oracle DB binds variable by name, so bind names in statement must be sorted to address them.
    1.5. Oracle DB handles NULL/DEFAULT values with specific way.
    1.6. Oracle DB returns NULL value as true PHP null
    1.7. Oracle DB handles sequence access with specific syntax
    1.8. Nothing returned by db_prepare_string() in case of oci8
    1.9. Oracle DB max object length is 30 chars, so table names must be reduced
    1.10. Oracle DB uses LOB literal format similar to mssql
    1.11. GetRowAssoc returns empty field values with oci8, it's need to enable returning both associative and indexed arrays.
Tagspatch

Relationships

related to 0013272 closeddregad Hardcoded table name mantis_config_table in install.php 
related to 0010488 closeddregad Inserting strings > 4000 Bytes not working -> direct file upload and email 
related to 0007190 closeddregad error in filter_api with date filter 
parent of 0006853 closeddregad Instalation in oracle Database ... 
parent of 0007644 closeddregad Problems when creating the Mantis database schema on Oracle 
parent of 0010437 closeddregad APPLICATION WARNING #403: Database field "description" not found. 
parent of 0010996 closeddregad Cant use Mantis with oracle9 - var binding fails 
parent of 0011265 closeddregad Array results from Oracle have uppercase keys 
parent of 0011270 closeddregad db_insert_id is wrong for Oracle 
parent of 0011276 closeddregad db_param sometimes creating duplicate 
parent of 0012152 closeddregad Indexes already created 
parent of 0012478 closeddregad Installation with Oracle fails 
parent of 0006895 closeddregad install mantis with oracle (driver oci8) 
parent of 0008686 closeddregad Pb on : "Attempting to connect to database as admin" 
parent of 0007185 closeddregad Empty string incompatibility mysql/oracle 
parent of 0012151 closeddregad Oracle database_api.php fatal error on install 
parent of 0007935 closeddregad Problem with install / connexion / filtre 
parent of 0007246 closeddregad Not possible to use singup functionality 
parent of 0007126 closeddregad For the execution of Mantis in Oracle 8i, 9i 
parent of 0014563 closeddregad Use of literal SQL statement causes ORA-01704 error when uploading attachments 
parent of 0011014 closeddregad Database creation SQL scripts may be more handy 
parent of 0015426 closeddregad GetRowAssoc fails with Oracle DB 
parent of 0012267 closeddregad Custom Field Title and Value render as '@', $t_custom_field, '@'; in Oracle 
parent of 0016330 closeddregad html_status_percentage_legend() causes error ORA-00923 
parent of 0016331 closeddregad Attaching file causes ORA-01400: cannot insert NULL into BLOB column 
parent of 0016336 closeddregad File attachment to DB fails when file bigger than 4000 bytes on Oracle 
parent of 0016351 closeddregad DB creation failed with ORA-01031 
parent of 0010490 closed Some queries don't work due to the use of "AS" in table alias 
has duplicate 0016832 closeddregad Cannot insert NULL values 
related to 0007179 closeddregad limit selection required for oracle (probleme viewed at the page my_view_page.php) 
related to 0013433 closeddregad Error ORA-00904: "PROTECTED": invalid identifier for the query 

Activities

DKuranov

DKuranov

2011-08-09 09:30

reporter  

database_api.php (13,127 bytes)
--- mantis_orig_1.2.6/core/database_api.php	Tue Jul 26 08:49:10 2011
+++ mantis_patched_1.2.6/core/database_api.php	Tue Aug  9 17:08:26 2011
@@ -56,7 +56,11 @@
  * set adodb fetch mode
  * @global bool $ADODB_FETCH_MODE
  	 */
-$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;
+if( $GLOBALS['g_db_type'] == 'oci8' )
+	# To get non-empty field values in case of oci8 from GetRowAssoc() indexed result returning must be enabled 
+	$ADODB_FETCH_MODE = ADODB_FETCH_BOTH;
+else
+	$ADODB_FETCH_MODE = ADODB_FETCH_ASSOC;
 
 /**
  * Tracks the query parameter count for use with db_aparam().
@@ -263,6 +267,9 @@
 		}
 	}
 
+	if( $GLOBALS['g_db_type'] == 'oci8' )
+		$p_query = adopt_query_syntax_ora( $p_query );
+
 	if(( $p_limit != -1 ) || ( $p_offset != -1 ) ) {
 		$t_result = $g_db->SelectLimit( $p_query, $p_limit, $p_offset );
 	} else {
@@ -334,6 +341,9 @@
 		}
 	}
 
+	if( $GLOBALS['g_db_type'] == 'oci8' )	{
+		$p_query = adopt_query_syntax_ora( $p_query , $arr_parms );
+	}
 	if(( $p_limit != -1 ) || ( $p_offset != -1 ) ) {
 		$t_result = $g_db->SelectLimit( $p_query, $p_limit, $p_offset, $arr_parms );
 	} else {
@@ -452,6 +462,15 @@
 		static $t_array_result;
 		static $t_array_fields;
 
+		# Oci8 returns null values for empty strings
+		if( $g_db_type == 'oci8' )	{
+			foreach( $t_row as $k => &$v )	{
+				if( $v=='' && $v!=='' )	{
+					$v='';
+				}
+			}
+		}
+
 		if ($t_array_result != $p_result) {
 			// new query
 			$t_array_result = $p_result;
@@ -531,11 +550,21 @@
  */
 function db_insert_id( $p_table = null, $p_field = "id" ) {
 	global $g_db;
+	$t_db_type = config_get_global( 'db_type' );
 
-	if( isset( $p_table ) && db_is_pgsql() ) {
-		$query = "SELECT currval('" . $p_table . "_" . $p_field . "_seq')";
-		$result = db_query_bound( $query );
-		return db_result( $result );
+	if( isset( $p_table ) ) {
+		switch( $t_db_type ) {
+			case 'pgsql':
+				$query = "SELECT currval('" . $p_table . "_" . $p_field . "_seq')";
+				break;
+			case 'oci8':
+				$query = "SELECT seq_" . $p_table . ".CURRVAL FROM DUAL";
+				break;
+		}
+		if( isset( $query ) )	{
+			$result = db_query_bound( $query );
+			return db_result( $result );
+		}
 	}
 	return $g_db->Insert_ID();
 }
@@ -710,6 +739,8 @@
 		case 'postgres7':
 		case 'pgsql':
 			return pg_escape_string( $p_string );
+		case 'oci8':
+			return $p_string;
 		default:
 			error_parameters( 'db_type', $t_db_type );
 			trigger_error( ERROR_CONFIG_OPT_INVALID, ERROR );
@@ -739,6 +770,9 @@
 		case 'pgsql':
 			return '\'' . pg_escape_bytea( $p_string ) . '\'';
 			break;
+		case 'oci8':
+			$content = unpack( "H*hex", $p_string );
+			return '\'' . $content['hex'] . '\'';
 		default:
 			return '\'' . db_prepare_string( $p_string ) . '\'';
 			break;
@@ -892,6 +926,10 @@
 		if( $t_value !== $GLOBALS['g_db_table'][$p_option] ) {
 			$GLOBALS['g_db_table'][$p_option] = $t_value;
 		}
+		# Oci8 not support long object names(30 chars max), reducing table names
+		if( $GLOBALS['g_db_type'] == 'oci8' )	{
+			$t_value = str_replace( '_table' , '' , $t_value );
+		}
 		return $t_value;
 	} else {
 		error_parameters( $p_option );
@@ -922,3 +960,193 @@
 	if (!defined('PLUGINS_DISABLED') )
 		define( 'PLUGINS_DISABLED', true );
 }
+
+
+/**
+ * Sorts bind variable numbers. input: "... WHERE F1=:12 and F2=:97 ", output: "... WHERE F1=:0 and F2=:1 ". Used in adopt_query_syntax_ora(). 
+ * @param string $p_query Query string to sort
+ * @return string Query string with sorted bind variable numbers.
+ */
+function order_binds_sequentally( $p_query )	{
+	$t_new_query= '';
+	$t_is_odd = true;
+	$t_after_quote = false;
+	$t_iter = 0;
+
+	# Divide statement to skip processing string literals
+	$t_p_query_arr = explode( '\'' , $p_query );
+	foreach( $t_p_query_arr as $t_p_query_part )	{
+		if( $t_new_query != '' )
+			$t_new_query = $t_new_query . '\'';
+		if( $t_is_odd )   {
+			# Divide to process all bindvars  
+			$t_p_query_subpart_arr = explode( ':' , $t_p_query_part );
+			if( count( $t_p_query_subpart_arr ) > 1 )     {
+				foreach( $t_p_query_subpart_arr as $t_p_query_subpart )  {
+					if( ( !$t_after_quote ) && ( $t_new_query != '' ) )	{
+						$t_new_query = $t_new_query . ":";
+
+						$t_new_query = $t_new_query . preg_replace( '/^(\d+?)/U' , strval( $t_iter ) , $t_p_query_subpart );
+						$t_iter = $t_iter + 1;
+					}else	{
+						$t_new_query = $t_new_query . $t_p_query_subpart;
+					}
+					$t_after_quote = false;
+				}
+			}else	{
+				$t_new_query = $t_new_query . $t_p_query_part;
+			}
+                        $t_is_odd = false;
+                } else   {
+			$t_after_quote = true;
+			$t_new_query = $t_new_query . $t_p_query_part;
+			$t_is_odd = true;
+		}
+	}
+	return $t_new_query;
+}
+
+/**
+ * Adopt input query string and bindvars array to Oracle DB syntax:
+ * 1. Change bind vars id's to sequence beginnging with 0(calls order_binds_sequentally() )
+ * 2. Remove "AS" keyword, because it not supported with table aliasing
+ * 3. Remove null bind variables in insert statements for default values support
+ * 4. Replace "tab.column=:bind" to "tab.column IS NULL" when :bind is empty string
+ * 5. Replace "SET tab.column=:bind" to "SET tab.column=DEFAULT" when :bind is empty string
+ * @param string $p_query Query string to sort
+ * @param array $arr_parms Array of parameters matching $p_query, function sorts array keys
+ * @return string Query string with sorted bind variable numbers.
+ */
+function adopt_query_syntax_ora( $p_query , &$arr_parms = null )  {
+	# Remove "AS" keyword, because not supported with table aliasing
+	$p_query = preg_replace( '/ AS /im' , ' ' , $p_query );
+
+	# Remove null bind variables in insert statements for default values support
+	if( is_array ( $arr_parms ) )        {		
+		preg_match( '/^[\s\n\r]*insert[\s\n\r]+(into){0,1}[\s\n\r]+(?P<table>[a-z0-9_]+)[\s\n\r]*\([\s\n\r]*[\s\n\r]*(?P<fields>[a-z0-9_,\s\n\r]+)[\s\n\r]*\)[\s\n\r]*values[\s\n\r]*\([\s\n\r]*(?P<values>[:a-z0-9_,\s\n\r]+)\)/i' , $p_query , $t_matches );
+                if(isset($t_matches['values'])) { #if statement is a INSERT INTO ... (...) VALUES(...)
+			$i = 0; # iterates non-empty bind variables
+			$t_fields_left = $t_matches['fields'];
+			$t_values_left = $t_matches['values'];
+
+			for( $t_arr_index = 0 ; $t_arr_index < count($arr_parms) ; $t_arr_index++ ) {
+				#inserting fieldname search
+				if( preg_match( '/^[\s\n\r]*([a-z0-9_]+)[\s\n\r]*,{0,1}([\d\D]*)\z/i' , $t_fields_left , $t_fieldmatch ) )    {
+					$t_fields_left = $t_fieldmatch[2];
+					$t_fields_arr[$i] = $t_fieldmatch[1];
+				}
+				#inserting bindvar name search
+				if( preg_match( '/^[\s\n\r]*(:[a-z0-9_]+)[\s\n\r]*,{0,1}([\d\D]*)\z/i' , $t_values_left , $t_valuematch ) )   {
+					$t_values_left = $t_valuematch[2];
+					$t_values_arr[$i] = $t_valuematch[1];
+				}
+				#skip unsetting if bind array value not empty
+				if( $arr_parms[$t_arr_index] !== '' )	{
+					$i = $i + 1;
+				}
+				else    {
+					$t_arr_index = $t_arr_index - 1;
+					#Shift array and unset bind array element
+					for( $n = $i + 1 ; $n < count( $arr_parms ) ; $n++ )	{
+						$arr_parms[$n-1] = $arr_parms[$n];
+					}
+					unset( $t_fields_arr[$i] );
+					unset( $t_values_arr[$i] );
+					unset( $arr_parms[count( $arr_parms ) - 1] );
+				}
+			}
+
+			#Combine statement from arrays
+			$p_query = 'INSERT INTO ' . $t_matches['table'] . ' (' . $t_fields_arr[0];
+			for( $i = 1 ; $i < count( $arr_parms ) ; $i++ )
+				$p_query = $p_query . ', ' . $t_fields_arr[$i];
+			$p_query = $p_query . ') values (' . $t_values_arr[0];
+			for ( $i = 1 ; $i < count( $arr_parms ) ; $i++ )
+				$p_query = $p_query . ', ' . $t_values_arr[$i]; 
+			$p_query = $p_query . ')';
+		}else	{ #if input statement is NOT a INSERT INTO (...) VALUES(...)
+
+			# "IS NULL" adoptation here
+			$t_set_where_template_str = substr( md5( uniqid( rand() , true)), 0, 50);
+			$t_removed_set_where = '';
+
+			# Need to order parameter array element correctly
+			$p_query = order_binds_sequentally( $p_query );
+
+			# Find and remove temporarily "SET var1=:bind1, var2=:bind2 WHERE" part
+			preg_match( '/^(?P<before_set_where>.*)(?P<set_where>[\s\n\r]*set[\s\n\r]+[\s\n\ra-z0-9_\.=,:\']+)(?P<after_set_where>where[\d\D]*)$/i' , $p_query, $t_matches );
+			$t_set_where_stmt = isset( $t_matches['after_set_where'] );
+
+			if( $t_set_where_stmt )	{					
+				$t_removed_set_where = $t_matches['set_where'];
+				#Now work with statement without "SET ... WHERE" part
+				$t_templated_query = $t_matches['before_set_where'] . $t_set_where_template_str . $t_matches['after_set_where'];
+			}else	{
+				$t_templated_query = $p_query;
+			}
+
+			#Replace "var1=''" to "var1 IS NULL"
+			while( preg_match( '/^(?P<before_empty_literal>[\d\D]*[\s\n\r(]+([a-z0-9_]*[\s\n\r]*\.){0,1}[\s\n\r]*[a-z0-9_]+)[\s\n\r]*=[\s\n\r]*\'\'(?P<after_empty_literal>[\s\n\r]*[\d\D]*\z)/i' , $t_templated_query , $t_matches ) > 0 )	{
+				$t_templated_query = $t_matches['before_empty_literal'] . " IS NULL " . $t_matches['after_empty_literal'];
+			}
+			#Replace "var1!=''" and "var1<>''" to "var1 IS NOT NULL"
+			while( preg_match('/^(?P<before_empty_literal>[\d\D]*[\s\n\r(]+([a-z0-9_]*[\s\n\r]*\.){0,1}[\s\n\r]*[a-z0-9_]+)[\s\n\r]*(![\s\n\r]*=|<[\s\n\r]*>)[\s\n\r]*\'\'(?P<after_empty_literal>[\s\n\r]*[\d\D]*\z)/i' , $t_templated_query , $t_matches ) > 0 )	{
+				$t_templated_query = $t_matches['before_empty_literal'] . " IS NOT NULL " . $t_matches['after_empty_literal'];
+			}
+
+			$p_query = $t_templated_query;
+			# Process input bind variable array to replace "WHERE fld=:12" to "WHERE fld IS NULL" if :12 is empty
+			while( preg_match( '/^(?P<before_var>[\d\D]*[\s\n\r(]+)(?P<var_name>([a-z0-9_]*[\s\n\r]*\.){0,1}[\s\n\r]*[a-z0-9_]+)(?P<dividers>[\s\n\r]*=[\s\n\r]*:)(?P<bind_name>[0-9]+)(?P<after_var>[\s\n\r]*[\d\D]*\z)/i' , $t_templated_query , $t_matches ) > 0 )	{
+				$t_bind_num = $t_matches['bind_name'];
+
+				$t_search_substr = $t_matches['before_var'] . $t_matches['var_name'] . $t_matches['dividers'] . $t_matches['bind_name'] . $t_matches['after_var'];
+				$t_replace_substr = $t_matches['before_var'] . $t_matches['var_name'] . "=:" . $t_matches['bind_name']. $t_matches['after_var'];
+
+				if( $arr_parms[$t_bind_num] === '' )	{
+					for( $n = $t_bind_num + 1 ; $n < count($arr_parms) ; $n++ )	{
+						$arr_parms[$n - 1] = $arr_parms[$n];
+					}
+					unset( $arr_parms[count( $arr_parms ) - 1] );
+					$t_replace_substr = $t_matches['before_var'] . $t_matches['var_name'] . " IS NULL " . $t_matches['after_var'];
+				}
+				$p_query = str_replace( $t_search_substr , $t_replace_substr , $p_query );
+
+				$t_templated_query = $t_matches['before_var'] . $t_matches['after_var'];
+			}
+
+			if( $t_set_where_stmt )	{
+				#Return temporary removed "SET ... WHERE" part
+				$p_query = str_replace( $t_set_where_template_str , $t_removed_set_where , $p_query );
+				# Need to order parameter array element correctly
+				$p_query = order_binds_sequentally( $p_query );
+				# Find and remove temporary "SET var1=:bind1, var2=:bind2 WHERE" part again
+				preg_match( '/^(?P<before_set_where>.*)(?P<set_where>[\s\n\r]*set[\s\n\r]+[\s\n\ra-z0-9_\.=,:\']+)(?P<after_set_where>where[\d\D]*)$/i' , $p_query , $t_matches );
+				$t_removed_set_where = $t_matches['set_where'];
+				$p_query = $t_matches['before_set_where'] . $t_set_where_template_str . $t_matches['after_set_where'];
+
+				#Replace "SET fld1=:1" to "SET fld1=DEFAULT" if bind array value is empty
+				$t_removed_set_where_parsing = $t_removed_set_where;
+
+				while( preg_match( '/^(?P<before_var>[\d\D]*[\s\n\r,]+)(?P<var_name>([a-z0-9_]*[\s\n\r]*\.){0,1}[\s\n\r]*[a-z0-9_]+)(?P<dividers>[\s\n\r]*=[\s\n\r]*:)(?P<bind_name>[0-9]+)(?P<after_var>[,\s\n\r]*[\d\D]*\z)/i' , $t_removed_set_where_parsing , $t_matches ) > 0 )	{
+					$t_bind_num = $t_matches['bind_name'];
+					$t_search_substr = $t_matches['before_var'] . $t_matches['var_name'] . $t_matches['dividers'] . $t_matches['bind_name'] ;
+					$t_replace_substr = $t_matches['before_var'] . $t_matches['var_name'] . $t_matches['dividers'] . $t_matches['bind_name'] ;
+
+					if( $arr_parms[$t_bind_num] === '' )	{
+						for( $n = $t_bind_num + 1 ; $n < count( $arr_parms ) ; $n++ )	{
+							$arr_parms[$n - 1] = $arr_parms[ $n ];
+						}
+						unset( $arr_parms[count( $arr_parms ) - 1] );
+						$t_replace_substr = $t_matches['before_var'] . $t_matches['var_name'] . "=DEFAULT ";
+					}
+					$t_removed_set_where = str_replace( $t_search_substr , $t_replace_substr , $t_removed_set_where );
+					$t_removed_set_where_parsing = $t_matches['before_var'] . $t_matches['after_var'];
+				}
+				$p_query = str_replace( $t_set_where_template_str , $t_removed_set_where , $p_query );
+			}
+		}		
+	}
+	$p_query = order_binds_sequentally( $p_query );
+        return $p_query;
+}
+
database_api.php (13,127 bytes)
DKuranov

DKuranov

2011-08-09 09:31

reporter  

install.php (800 bytes)
--- mantis_orig_1.2.6/admin/install.php	Tue Jul 26 08:49:10 2011
+++ mantis_patched_1.2.6/admin/install.php	Thu Jul 28 14:10:22 2011
@@ -245,7 +245,7 @@
 
 <?php print_test( 'Setting Database Username', '' !== $f_db_username, true, 'database username is blank' )?>
 <?php print_test( 'Setting Database Password', '' !== $f_db_password, false, 'database password is blank' )?>
-<?php print_test( 'Setting Database Name', '' !== $f_database_name, true, 'database name is blank' )?>
+<?php print_test( 'Setting Database Name', '' !== $f_database_name || $f_db_type == 'oci8' , true, 'database name is blank' )?>
 <?php
 	if( $f_db_type == 'db2' ) {
 		print_test( 'Setting Database Schema', !is_blank( $f_db_schema ), true, 'must have a schema name for AS400 in the form of DBNAME/SCHEMA' );
install.php (800 bytes)
DKuranov

DKuranov

2011-08-09 09:31

reporter  

manage_tags_page.php (473 bytes)
--- mantis_orig_1.2.6/manage_tags_page.php	Tue Jul 26 08:49:12 2011
+++ mantis_patched_1.2.6/manage_tags_page.php	Thu Jul 28 14:10:28 2011
@@ -147,7 +147,7 @@
 		<td width="20%"><?php echo lang_get( 'tag_updated' ) ?></td>
 	</tr>
 <?php
-foreach ( $t_result as $t_tag_row ) {
+while ( $t_tag_row = db_fetch_array( $t_result ) ) {
 	$t_tag_name = string_display_line( $t_tag_row['name'] );
 	$t_tag_description = string_display( $t_tag_row['description'] );
 ?>
manage_tags_page.php (473 bytes)
DKuranov

DKuranov

2011-08-09 09:31

reporter  

schema.php (7,929 bytes)
--- mantis_orig_1.2.6/admin/schema.php	Tue Jul 26 08:49:10 2011
+++ mantis_patched_1.2.6/admin/schema.php	Thu Jul 28 14:10:36 2011
@@ -228,7 +228,9 @@
   file_path 		C(250) NOTNULL DEFAULT \" '' \",
   description 		XL NOTNULL
 ",Array('mysql' => 'ENGINE=MyISAM DEFAULT CHARSET=utf8', 'pgsql' => 'WITHOUT OIDS')));
-$upgrade[] = Array('CreateIndexSQL',Array('idx_project_id',db_get_table('mantis_project_table'),'id'));
+# Index autocreated when oci used
+if( $GLOBALS['g_db_type'] != 'oci8' )
+	$upgrade[] = Array('CreateIndexSQL',Array('idx_project_id',db_get_table('mantis_project_table'),'id'));
 $upgrade[] = Array('CreateIndexSQL',Array('idx_project_name',db_get_table('mantis_project_table'),'name',Array('UNIQUE')));
 $upgrade[] = Array('CreateIndexSQL',Array('idx_project_view',db_get_table('mantis_project_table'),'view_state'));
 $upgrade[] = Array('CreateTableSQL',Array(db_get_table('mantis_project_user_list_table'),"
@@ -334,10 +336,17 @@
 $upgrade[] = Array('CreateIndexSQL',Array('idx_enable',db_get_table('mantis_user_table'),'enabled'));
 /* 50 */
 $upgrade[] = Array('CreateIndexSQL',Array('idx_access',db_get_table('mantis_user_table'),'access_level'));
-$upgrade[] = Array('InsertData', Array( db_get_table('mantis_user_table'),
-    "(username, realname, email, password, date_created, last_visit, enabled, protected, access_level, login_count, lost_password_request_count, failed_login_count, cookie_string) VALUES
-        ('administrator', '', 'root@localhost', '63a9f0ea7bb98050796b649e85481845', '" . installer_db_now() . "', '" . installer_db_now() . "', '1', '0', 90, 3, 0, 0, '" .
-             md5( mt_rand( 0, mt_getrandmax() ) + mt_rand( 0, mt_getrandmax() ) ) . md5( time() ) . "')" ) );
+# Oci uses other date literal syntax 
+if( $GLOBALS['g_db_type'] != 'oci8' )
+	$upgrade[] = Array('InsertData', Array( db_get_table('mantis_user_table'),
+		"(username, realname, email, password, date_created, last_visit, enabled, protected, access_level, login_count, lost_password_request_count, failed_login_count, cookie_string) VALUES
+		('administrator', '', 'root@localhost', '63a9f0ea7bb98050796b649e85481845', '" . installer_db_now() . "', '" . installer_db_now() . "', '1', '0', 90, 3, 0, 0, '" .
+		md5( mt_rand( 0, mt_getrandmax() ) + mt_rand( 0, mt_getrandmax() ) ) . md5( time() ) . "')" ) );
+else
+	$upgrade[] = Array('InsertData', Array( db_get_table('mantis_user_table'),
+		"(username, realname, email, password, date_created, last_visit, enabled, protected, access_level, login_count, lost_password_request_count, failed_login_count, cookie_string) VALUES
+		('administrator', '', 'root@localhost', '63a9f0ea7bb98050796b649e85481845', timestamp" . installer_db_now() . ", timestamp" . installer_db_now() . ", '1', '0', 90, 3, 0, 0, '" .
+		md5( mt_rand( 0, mt_getrandmax() ) + mt_rand( 0, mt_getrandmax() ) ) . md5( time() ) . "')" ) );
 $upgrade[] = Array('AlterColumnSQL', Array( db_get_table( 'mantis_bug_history_table' ), "old_value C(255) NOTNULL" ) );
 $upgrade[] = Array('AlterColumnSQL', Array( db_get_table( 'mantis_bug_history_table' ), "new_value C(255) NOTNULL" ) );
 
@@ -349,7 +358,9 @@
   metadata 		XL NOTNULL,
   body 			XL NOTNULL
   ",Array('mysql' => 'ENGINE=MyISAM DEFAULT CHARSET=utf8', 'pgsql' => 'WITHOUT OIDS')));
-$upgrade[] = Array('CreateIndexSQL',Array('idx_email_id',db_get_table('mantis_email_table'),'email_id'));
+# Index autocreated when oci used
+if( $GLOBALS['g_db_type'] != 'oci8' )
+	$upgrade[] = Array('CreateIndexSQL',Array('idx_email_id',db_get_table('mantis_email_table'),'email_id'));
 $upgrade[] = Array('AddColumnSQL',Array(db_get_table('mantis_bug_table'), "target_version C(64) NOTNULL DEFAULT \" '' \""));
 $upgrade[] = Array('AddColumnSQL',Array(db_get_table('mantis_bugnote_table'), "time_tracking I UNSIGNED NOTNULL DEFAULT \" 0 \""));
 $upgrade[] = Array('CreateIndexSQL',Array('idx_diskfile',db_get_table('mantis_bug_file_table'),'diskfile'));
@@ -382,8 +393,12 @@
 	basename		C(40)	NOTNULL PRIMARY,
 	enabled			L		NOTNULL DEFAULT \" '0' \"
 	", Array( 'mysql' => 'ENGINE=MyISAM DEFAULT CHARSET=utf8', 'pgsql' => 'WITHOUT OIDS' ) ) );
+# Field cannot be null with oci because of empty string equals NULL 
+if( $GLOBALS['g_db_type'] != 'oci8' )
+	$upgrade[] = Array('AlterColumnSQL', Array( db_get_table( 'mantis_user_pref_table' ), "redirect_delay 	I NOTNULL DEFAULT 0" ) );
+else
+	$upgrade[] = Array('AlterColumnSQL', Array( db_get_table( 'mantis_user_pref_table' ), "redirect_delay 	I DEFAULT 0" ) );
 
-$upgrade[] = Array('AlterColumnSQL', Array( db_get_table( 'mantis_user_pref_table' ), "redirect_delay 	I NOTNULL DEFAULT 0" ) );
 
 /* apparently mysql now has a STRICT mode, where setting a DEFAULT value on a blob/text is now an error, instead of being silently ignored */
 if ( isset( $f_db_type ) && ( $f_db_type == 'mysql' || $f_db_type == 'mysqli' ) ) {
@@ -601,7 +616,11 @@
 $upgrade[] = Array( 'DropColumnSQL', Array( db_get_table( 'mantis_user_pref_table'), "advanced_view" ) );
 $upgrade[] = Array( 'DropColumnSQL', Array( db_get_table( 'mantis_user_pref_table'), "advanced_update" ) );
 $upgrade[] = Array( 'CreateIndexSQL', Array( 'idx_project_hierarchy_child_id', db_get_table( 'mantis_project_hierarchy_table' ), 'child_id' ) );
-$upgrade[] = Array( 'CreateIndexSQL', Array( 'idx_project_hierarchy_parent_id', db_get_table( 'mantis_project_hierarchy_table' ), 'parent_id' ) );
+# Decrease index name length for oci8(30 chars max)
+if( $GLOBALS['g_db_type'] != 'oci8' )
+	$upgrade[] = Array( 'CreateIndexSQL', Array( 'idx_project_hierarchy_parent_id', db_get_table( 'mantis_project_hierarchy_table' ), 'parent_id' ) );
+else
+	$upgrade[] = Array( 'CreateIndexSQL', Array( 'idx_prj_hier_parent_id', db_get_table( 'mantis_project_hierarchy_table' ), 'parent_id' ) );
 
 /* 180 */
 $upgrade[] = Array( 'CreateIndexSQL', Array( 'idx_tag_name', db_get_table( 'mantis_tag_table' ), 'name' ) );
@@ -608,3 +627,19 @@
 $upgrade[] = Array( 'CreateIndexSQL', Array( 'idx_bug_tag_tag_id', db_get_table( 'mantis_bug_tag_table' ), 'tag_id' ) );
 $upgrade[] = Array( 'CreateIndexSQL', Array( 'idx_email_id', db_get_table( 'mantis_email_table' ), 'email_id', array( 'DROP' ) ), Array( 'db_index_exists', Array( db_get_table( 'mantis_email_table' ), 'idx_email_id') ) );
 $upgrade[] = Array( 'UpdateFunction', 'correct_multiselect_custom_fields_db_format' );
+
+# Field cannot be null with oci because of empty string equals NULL 
+if( $GLOBALS['g_db_type'] == 'oci8' )	{
+	$upgrade[] = Array('AlterColumnSQL', Array( db_get_table( 'mantis_bug_table' ), "sticky NULL" ) );
+	$upgrade[] = Array('AlterColumnSQL', Array( db_get_table( 'mantis_bug_history_table' ), "new_value NULL" ) );
+	$upgrade[] = Array('AlterColumnSQL', Array( db_get_table( 'mantis_bug_history_table' ), "old_value NULL" ) );
+	$upgrade[] = Array('AlterColumnSQL', Array( db_get_table( 'mantis_bug_history_table' ), "field_name NULL" ) );
+	$upgrade[] = Array('AlterColumnSQL', Array( db_get_table( 'mantis_bug_text_table' ), "additional_information  NULL" ) );
+	$upgrade[] = Array('AlterColumnSQL', Array( db_get_table( 'mantis_bug_text_table' ), "steps_to_reproduce NULL" ) );
+	$upgrade[] = Array('AlterColumnSQL', Array( db_get_table( 'mantis_project_table' ), "description NULL" ) );
+	$upgrade[] = Array('AlterColumnSQL', Array( db_get_table( 'mantis_project_version_table' ), "description NULL" ) );
+	$upgrade[] = Array('AlterColumnSQL', Array( db_get_table( 'mantis_tag_table' ), "description NULL" ) );
+	$upgrade[] = Array('AlterColumnSQL', Array( db_get_table( 'mantis_user_pref_table' ), "email_on_priority NULL" ) );
+	$upgrade[] = Array('AlterColumnSQL', Array( db_get_table( 'mantis_user_pref_table' ), "email_on_status NULL" ) );
+	$upgrade[] = Array('AlterColumnSQL', Array( db_get_table( 'mantis_user_profile_table' ), "description NULL" ) );
+}
schema.php (7,929 bytes)
DKuranov

DKuranov

2011-08-09 09:34

reporter   ~0029411

Last edited: 2011-08-09 11:56

View 2 revisions

Patchset against Mantis 1.2.6 submitted.
Bundled tests completed successfully for Oracle and MySQL.
It seems bugs 0006853, 0007644, 0010437, 0010996, 0011265, 0011270, 0011276, 0012152, 0012478 can be resolved.

dregad

dregad

2011-08-09 11:50

developer   ~0029415

Hello

Many thanks for your patch and testing. Would you be able to make this a git patch, or even better a pull request on github ?

DKuranov

DKuranov

2011-08-10 04:17

reporter   ~0029433

Sorry, but I have no experience/knowledge in git.

dregad

dregad

2011-08-10 12:36

developer   ~0029448

OK I'll try to apply the changes to 1.2.x branch, and will bounce it off the other developers. Will you be able to test afterwards ?

Also, if that goes through, are you willing to contribute porting the changes to 1.3.x master branch ?

Would you like to be credited as author of the git commit (your name and e-mail would appear in the git repository), or as a comment in the commit description ?

dregad

dregad

2011-08-10 12:57

developer   ~0029449

I have a question regarding the changes in schema.php, where you handle the problem of "fields cannot be null" in two different places:

  • @@ -382,8 +393,12 @@
    ==> you change the column definition directly
  • @@ -608,3 +627,19 @@ ==> you alter the columns after they have been created

Is there a particular reason for not directly creating the columns as they should be, i.e. during the initial CreateTableSQL or AddColumnSQL call ?

DKuranov

DKuranov

2011-08-10 13:26

reporter   ~0029450

Will you be able to test afterwards ?
You mean running testsuite on nightly build of 1.2.x branch? Ok, it's possible.
porting the changes to 1.3.x master
I'll try. If database_api not heavily changed it's easy.
credited as author of the git commit
Not sufficient.
not directly creating the columns as ...
Not sufficient, I cant't find any reason to choice any of them(for the present we using 1.2.4 adoptated quickly, not qualitatively). As true DB upgrade it's not applicable because any of people using Mantis with Oracle choose different ways to resolve short object name limitation.

dregad

dregad

2011-08-10 13:54

developer   ~0029451

You mean running testsuite on nightly build of 1.2.x branch? Ok, it's possible.

Nice, thanks. Any additional "real life" usage test you could make would also be appreciated. I don't have an Oracle setup so it's not possible for me to do this.

What do you mean, by "Not sufficient" ? not necessary ?

people using Mantis with Oracle choose different ways to resolve short object name limitation

Likely, yes. But if this becomes part of master, then they will have to adapt their schema to match.

In any case, about the changes @@ -608,3 +627,19 @@, I will have to modify this as your code introduces a schema upgrade, which would break upwards compatibility with 1.3.x (so I guess that answers my own previous question).

DKuranov

DKuranov

2011-08-11 01:57

reporter   ~0029459

not necessary ?
Yes.
In any case, about the changes @@ -608,3 +627,19 @@, I will have to modify
Ok, agreed.

dregad

dregad

2011-08-11 13:38

developer   ~0029466

I put on github your patch plus my corrections / improvements.

https://github.com/dregad/mantisbt/tree/oracle

DKuranov

DKuranov

2011-08-17 01:31

reporter   ~0029491

I make a pull request "Fixed datetime literal format and bug with removing 'AS' from string literals", Tests passed with MySQL and Oracle.
Oracle installation requires only changing:

  1. $g_db_table_suffix: Just as planned, to reduce object name length
  2. $g_db_type: because of config_get_global( 'db_type' ) returns 'mysql' on installation stage
CarstenGrohmann

CarstenGrohmann

2011-08-28 14:56

reporter   ~0029576

Last edited: 2011-08-29 07:33

View 2 revisions

Hi dregad,

could you fix bug 13272 on your oracle trunk too, please?
I added a proper patch: patch-hardcoded_table_name-20110829.diff

Regards,
Carsten

CarstenGrohmann

CarstenGrohmann

2011-08-29 07:32

reporter  

patch-hardcoded_table_name-20110829.diff (816 bytes)
--- install.php.orig	2011-08-29 13:01:10.009007000 +0200
+++ install.php	2011-08-29 13:28:49.901613000 +0200
@@ -740,7 +740,7 @@
 		}
 		if( $f_log_queries ) {
 			# add a query to set the database version
-			echo 'INSERT INTO mantis_config_table ( value, type, access_reqd, config_id, project_id, user_id ) VALUES (\'' . $lastid . '\', 1, 90, \'database_version\', 0, 0 );' . "\r\n";
+			echo 'INSERT INTO ' . db_get_table( 'mantis_config_table' ) . ' ( value, type, access_reqd, config_id, project_id, user_id ) VALUES (\'' . $lastid . '\', 1, 90, \'database_version\', 0, 0 );' . "\r\n";
 			echo '</pre></br /><p style="color:red">Your database has not been created yet. Please create the database, then install the tables and data using the information above before proceeding.</td></tr>';
 		}
 	}
dregad

dregad

2011-08-29 09:14

developer   ~0029591

I have updated the github branch including DKuranov's pull request as well as the fix for hardcoded table name. Please test and let me know if it's working OK now.

https://github.com/dregad/mantisbt/commits/oracle

CarstenGrohmann

CarstenGrohmann

2011-08-29 09:35

reporter   ~0029593

Last edited: 2011-08-29 10:56

View 2 revisions

Oracle supports DB bindings in two ways:

  1. Use hostname, username/password and database name
  2. Use tns name (insert into hostname field) and username/password, database name is still empty

We use method 2 :-)

The patch patch-check_oracle_db_params-20110829-2.diff improve the check in install.php

PS: Please delete (or ignore) patch-check_oracle_db_params-20110829.diff. It's buggy.

DKuranov

DKuranov

2011-08-29 10:03

reporter   ~0029594

Last edited: 2011-08-29 10:04

View 2 revisions

Pull request for Mantis 1.3 created.
https://github.com/dregad/mantisbt/pull/2

CarstenGrohmann

CarstenGrohmann

2011-08-29 10:19

reporter  

patch-check_oracle_db_params-20110829-2.diff (1,437 bytes)
--- install.php.orig	2011-08-29 14:51:53.730166000 +0200
+++ install.php	2011-08-29 15:27:50.870287000 +0200
@@ -165,7 +165,14 @@
 
 	if( 0 == $t_install_state ) {
 		print_test( 'Setting Database Type', '' !== $f_db_type, true, 'database type is blank?' );
-		print_test( 'Checking Database connection settings exist', ( $f_dsn !== '' || ( $f_database_name !== '' && $f_db_username !== '' && $f_hostname !== '' ) ), true, 'database connection settings do not exist?' );
+		# Oracle supports binding in two ways:
+		#  - hostname, username/password and database name
+		#  - tns name (insert into hostname field) and username/password, database name is still empty
+		if ( $f_db_type == 'oci8' ) {
+			print_test( 'Checking Database connection settings exist', ( $f_dsn !== '' || ( $f_database_name !== '' && $f_db_username !== '' && $f_hostname !== '' ) || ( $f_database_name == '' && $f_db_username !== '' && $f_hostname !== '' ) ), true, 'database connection settings do not exist?' );
+		} else {
+			print_test( 'Checking Database connection settings exist', ( $f_dsn !== '' || ( $f_database_name !== '' && $f_db_username !== '' && $f_hostname !== '' ) ), true, 'database connection settings do not exist?' );
+		}
 		print_test( 'Checking PHP support for database type', db_check_database_support( $f_db_type ), true, 'database is not supported by PHP. Check that it has been compiled into your server.' );
 	}
 
CarstenGrohmann

CarstenGrohmann

2011-08-29 11:58

reporter   ~0029596

Last edited: 2011-08-30 02:25

View 2 revisions

We installed the current git oracle branch (63ae01ac8856a054f0f5) plus patch-check_oracle_db_params-20110829-2.diff successfully.

But got some minor issues.

Issue 1: config_inc.php without database details doesn't work

One or two tables names are longer than 32 characters. Thereby Oracle raised an error for this tables.
Just adding $g_db_table_suffix="m" and $g_db_table_prefix="_t" to config_inc.php doesn't work. install.php complain about unknown database type. Adding $g_db_type="oci8" changed the behaviour. Now we got the input mask for database connection details. The inserted values wasn't used. Looks like install.php uses the default values localhost and root.
After providing the full database parameters in config_inc.php ($g_hostname, $g_db_type, $g_database_name, $g_db_username, $g_db_password, $g_db_table_suffix, $g_db_table_prefix) the installation runs fine.

Issue 2: Printed SQL Queries don't work with sqlplus

Like already mentioned (eg 0007644 or 0012478) : create trigger have to end with "END;\n/" instead of printed "END;;". It looks like the trigger statements are from ado oracle code.

Probably the output code in admin/install.php line 719? caused the ";;"
if( $f_log_queries ) {
if( $t_sql ) {
foreach( $sqlarray as $sql ) {
echo htmlentities( $sql ) . ";\r\n\r\n";

Needs special handling for ORACLE TRIGGERS

            }
    }

}

The patch patch-oracle_create_trigger-20110830.diff changes this behaviour.

Enough today :-)

CarstenGrohmann

CarstenGrohmann

2011-08-30 02:24

reporter  

patch-oracle_create_trigger-20110830.diff (617 bytes)
--- install.php.orig	2011-08-29 16:49:43.906309000 +0200
+++ install.php	2011-08-30 08:21:30.090113000 +0200
@@ -718,7 +718,12 @@
 			if( $f_log_queries ) {
 				if( $t_sql ) {
 					foreach( $sqlarray as $sql ) {
-						echo htmlentities( $sql ) . ";\r\n\r\n";
+						# "CREATE OR REPLACE TRIGGER" statements has to end with "END;\n/" for Oracle sqlplus
+						if ( $f_db_type == 'oci8' && stripos( $sql, 'CREATE OR REPLACE TRIGGER' ) === 0 ) {
+							echo htmlentities( $sql ) . "\r\n/\r\n\r\n";
+						} else {
+							echo htmlentities( $sql ) . ";\r\n\r\n";
+						}
 					}
 				}
 			} else {
CarstenGrohmann

CarstenGrohmann

2011-08-30 07:57

reporter   ~0029598

We tested a mantis setup with two separate database accounts (schema owner and database user) yesterday. It looks like Mantis checks the existence of the database tables using the database user at every? access. This check is failing because the database user didn't see the database tables created by the schema owner.

dregad

dregad

2011-09-02 06:23

developer   ~0029622

Last edited: 2011-09-02 06:24

View 2 revisions

Hi Carsten,

Thanks for your patches, I have integrated them to the branch on github. Please review and test.

Regarding Issue 1 in 0013227:0029596, I don't really understand the problem - can you provide some context or additional info ?

Please bear in mind that I do not have an environment available for testing this, so I must rely on you an others who are using Oracle to check that this works.

About the thing with separate accounts schema vs user, I know it's a thing that Oracle DBAs like to do for security/maintenance reasons, but if it does not work as is, then I don't think Mantis code can be easily modified to cope with that setup. You might want to double-check the object grants given to the mantis user by the mantis schema in case they are not correct, and maybe create synonyms.

To DKuranov - maybe a bit premature for porting to 1.3.x, but thanks for the effort.

CarstenGrohmann

CarstenGrohmann

2011-09-02 10:32

reporter   ~0029627

Last edited: 2011-09-02 10:33

View 4 revisions

Hi Damien,

regarding issue 1: I think the issue is caused by the way install.php handles existing but incomplete config_inc.php files. It looks like install.php uses in this situation the default values instead values entered into the form.

Steps to reproduce

  1. Start with a (really) new installation and new (empty) databases

  2. Create a four line config_inc.php file

    <?php
    $g_db_table_suffix="m";
    $g_db_table_prefix="_t"
    ?>

    to use short database names especially to prevent table names > 32 characters for Oracle.

  3. Call admin/install.php
    Error returned: "BAD database is not supported by PHP. Check that it has been compiled into your server."

  4. Add "$g_db_type='oci8'," to config_inc.php

  5. Call admin/install.php again
    Warning returned: "Config File Exists but Database does not" / "POSSIBLE PROBLEM Bad config_inc.php?"

  6. Fill form:
    Hostname (TNS Idenifier), DB user, DB user password, clear DB name, select "Print SQL Queries instead of Writing to the Database"

  7. Klick "Install/Upgrade Database"
    Warning returned: "POSSIBLE PROBLEM database password is blank" / "POSSIBLE PROBLEM admin user name is blank, using database user instead" (that's ok, Admin user was still empty)
    Error returned: "BAD Does administrative user have access to the database? ( ORA-12541: TNS:no listener )"
    Form filled with default values (hostname = localhost, user = root, database name = bugtracker, ...)

Is there an proved way to uses $g_db_table_suffix and $g_db_table_prefix from begin of the install process?

Regards,
Carsten

CarstenGrohmann

CarstenGrohmann

2011-09-02 10:42

reporter   ~0029628

A general note about Oracle RAC: Think about changing the sequences like "alter sequence ... nocache order;"

dregad

dregad

2011-09-02 12:04

developer   ~0029629

Last edited: 2011-09-02 12:32

View 2 revisions

Re: 0013227:0029627 - OK, now I get it ! I did not think about needing a partial config_inc.php file...

In that case I believe it probably makes more sense to preset the pre- and suffix to short values whenever the DB type is Oracle, directly in install.php. By doing so, we completely avoid the problem (seems easier than having to deal with some exception handling for an incomplete config_inc.php). Something like attached init-prefix-suffix.patch - What do you think ?

The sequences are not created directly by Mantis - this is handled by adodb so I'm not sure if what you ask for can be done without a change to the adodb library.

dregad

dregad

2011-09-02 12:31

developer  

init-prefix-suffix.patch (1,443 bytes)
diff --git a/admin/install.php b/admin/install.php
index 0501418..96153f9 100644
--- a/admin/install.php
+++ b/admin/install.php
@@ -650,6 +650,13 @@ if( 3 == $t_install_state ) {
 		# fake out database access routines used by config_get
 		$GLOBALS['g_db_type'] = $f_db_type;
 
+		# Initialize short table prefixes and suffix for Oracle
+		if ( $f_db_type == 'oci8' ) {
+			$GLOBALS['g_db_table_prefix']        = $t_db_table_prefix        = 'm';
+			$GLOBALS['g_db_table_plugin_prefix'] = $t_db_table_plugin_prefix = 'plg';
+			$GLOBALS['g_db_table_suffix']        = $t_db_table_suffix        = '_t';
+		}
+
 		# database_api references this
 		require_once( dirname( __FILE__ ) . DIRECTORY_SEPARATOR . 'schema.php' );
 		$g_db = ADONewConnection( $f_db_type );
@@ -820,8 +827,17 @@ if( 5 == $t_install_state ) {
 	$t_config .= "\t\$g_db_username = '$f_db_username';\r\n";
 	$t_config .= "\t\$g_db_password = '$f_db_password';\r\n";
 
-	if( $f_db_type == 'db2' ) {
-		$t_config .= "\t\$g_db_schema = '$f_db_schema';\r\n";
+	switch ( $f_db_type ) {
+		case 'db2':
+			$t_config .= "\t\$g_db_schema = '$f_db_schema';\r\n";
+			break;
+		case 'oci8':
+			$t_config .= "\t\$g_db_table_prefix = '$t_db_table_prefix';\r\n";
+			$t_config .= "\t\$g_db_table_plugin_prefix = '$t_db_table_plugin_prefix';\r\n";
+			$t_config .= "\t\$g_db_table_suffix = '$t_db_table_suffix';\r\n";
+			break;
+		default:
+			break;
 	}
 
 	$t_config .= '?>' . "\r\n";
init-prefix-suffix.patch (1,443 bytes)
CarstenGrohmann

CarstenGrohmann

2011-09-02 12:38

reporter   ~0029630

Your idea about the integration of the table suffix and prefix sounds good.
I can't contribute to this because my I don't have a deep knowledge about PHP.

The comment about the sequences was just a note for follower :-)

adou

adou

2011-10-21 07:35

reporter   ~0030017

New install from https://github.com/dregad/mantisbt/tree/ it's ok, but there is an error when start mantis (login_page.php):

"Database query failed. Error received from database was #904: ORA-00904: "PROTECTED": invalid identifier for the query: SELECT basename, priority, protected FROM m_plugin_t WHERE enabled=:0 ORDER BY priority DESC."

dregad

dregad

2011-10-21 09:18

developer   ~0030019

adou, I'll follow up on this problem in separate issue 0013433.

dregad

dregad

2011-10-25 13:21

developer   ~0030068

I implemented further fixes and improvements to the oracle branch.

Please download and test https://github.com/dregad/mantisbt/tree/oracle

dregad

dregad

2012-03-12 08:48

developer   ~0031431

Last edited: 2012-04-18 04:09

View 2 revisions

Release 1.2.9 merged into oracle branch - please download and test https://github.com/dregad/mantisbt/tarball/oracle-1.2.9

EDIT: Changed link to point to tarball of tag instead of branch head

adou

adou

2012-04-13 08:35

reporter   ~0031651

Downloaded and tested release 1.2.9 oracle.
It's ok!
Good job!
Thanks!

Karla

Karla

2012-04-17 11:48

reporter   ~0031675

Last edited: 2012-04-17 11:49

View 2 revisions

--- >>> With the tnsnames.ora file

DESENV =
(DESCRIPTION =
(ADDRESS_LIST =
(ADDRESS = (PROTOCOL = TCP) (HOST = 150.161.11.1) (PORT = 1521))
)
(CONNECT_DATA =
(SERVICE_NAME = desenv.com.br)
)
)

--- >>> And user data

hostname: dbdemo.desenv.com.br
database: desenv
user: system
password: system

--- >>> Fill in the data as follows:

Type of Database: Oracle

Hostname (for Database Server): dbdemo.desenv.com.br: 1521/desenv.com.br

Username (for Database): system

Password (for Database): system

Database name (for Database): desenv

Admin Username (to create Database if required): system

Admin Password (to create Database if required): system

--- >>> And it gives the following error:

Create database if it does not exist

    BAD

Does administrative user have access to create the database? ()

Attempting to connect to the database user

    POSSIBLE PROBLEM

Database user does not have access to the database (ORA-12545: Connect failed because target host or object does not exist)

Karla

Karla

2012-04-17 11:52

reporter   ~0031676

When I try the option: Print SQL Queries instead of Writing to the Database, it gives the following error:

Error processing XML: no element found
Position: http://150.161.11.43/mantis-oracle/admin/install.php
Line number 604, column 1:
^

dregad

dregad

2012-04-18 03:57

developer   ~0031679

Karla,

ORA-12545 generally means that you're not able to connect to the DB. This sounds like a local setup problem, not related to MantisBT or the configuration of the Oracle branch I'm maintaining.

With regards to the XML error, that's confusing to me as there is no XML involved in the installation process. You'd have to provide more information. However, I also don't think it's related to the oracle branch, so I suggest you ask your question as a separate issue, or use the Forums for support.

dregad

dregad

2012-04-18 04:05

developer   ~0031680

Release 1.2.10 has been merged into oracle branch [1] - please download and test !

Note that this is just a maintenance update to keep in sync with the latest MantisBT release. There have been no changes to the Oracle fixes themselves, so no additional tests are required if you have already done them for oracle-1.2.9.

[1] https://github.com/dregad/mantisbt/tarball/oracle-1.2.10

dregad

dregad

2012-06-07 03:53

developer   ~0032031

Release 1.2.11 has been merged into oracle branch [1] - please download and test !

Note that this is just a maintenance update to keep in sync with the latest MantisBT release. As with the 1.2.10 release, there have been no changes to the Oracle fixes themselves, so no additional tests are required if you have already done them for oracle-1.2.9.

[1] https://github.com/dregad/mantisbt/zipball/oracle-1.2.11

Note: as I write this there seems to be a problem with github because the above link yields a 'Server Error.' message

adou

adou

2012-06-11 06:43

reporter   ~0032067

I've found this link https://github.com/dregad/mantisbt/zipball/oracle for download Oracle release 1.2.11.
It's ok?

dregad

dregad

2012-06-11 07:07

developer   ~0032068

Last edited: 2012-07-05 10:04

View 2 revisions

The link you indicate is correct. However, note that it points to the branch head instead of the release tag, so it may contain additional changes (none at the moment).

However, Github still have an issue with the zip/tarball download as mentioned in my previous post; they are working on it. In the meanwhile, if you need the code, for the time being you'll have to clone the repository.

EDIT 05-Jul: Github have fixed the bug with the zip/tar download today

adou

adou

2012-07-12 04:24

reporter   ~0032307

I've downloaded the oracle branch zip (https://github.com/dregad/mantisbt/zipball/oracle-1.2.11)
I've tested it and it's ok!
Thanks!

dregad

dregad

2012-07-12 18:31

developer   ~0032319

Thanks for testing !

michalxo

michalxo

2012-07-16 03:58

reporter   ~0032342

Last edited: 2012-07-16 05:02

View 4 revisions

Hello!
I've tried adou's link to your newest mantis oracle db. Installation went without any problems on Oracle XE database version 11.2.0.2 on linux.

First problem (not so important): APPLICATION WARNING #100: Configuration option "database_version" not found.

Second problem: Reporting New Issue
Database query failed. Error received from database was 0001704: ORA-01704: string literal too long for the query: INSERT INTO m_bug_file_t
(bug_id, title, description, diskfile, filename, folder, filesize, file_type, date_added, content, user_id)
VALUES
(1, '', '', 'd81bba388aed666c7b91364208276a35', 'mantis_sql.txt', '', 30543, 'text/plain', '1342429120', '435245415445205441424c4520... ...2c20302c203020293b0d0a0d0a0d0a', 1).
Problem is in uploading text file containing sql queries.

Waiting for further instructions.
Thank you
Mich

dregad

dregad

2012-07-22 18:55

developer   ~0032356

Thanks for your message.

I'll try to have a look at the issues you reported as time allows (i.e. likely not before mid-August). In the meanwhile, could you provide additional information:

  1. knowing exactly at what step you got the warning will reduce the effort in trying to reproduce the problem, so a bit of context would be useful.

  2. if I understand correctly, you report a new issue with a file attachment in a single step. Does the error occur only with that file 'mantis_sql.txt', or with any file you try to upload ? If specific to the file, please attach it here. Do you also get the error if you try to upload the file after reporting the issue (i.e. as an update to an existing issue) ?

For my own reference, as a possible workaround for ORA-01704: https://forums.oracle.com/forums/thread.jspa?messageID=4332630

CarstenGrohmann

CarstenGrohmann

2012-08-07 09:12

reporter   ~0032489

We ran also in the ORA-01704 error. Our workaround is to store the attachments on disk ("$g_file_upload_method = DISK").

The literal SQL statements are limited to 2000 characters for Oracle. You've to use bind variables in such a case. See "Example 0000002 Inserting with bind variables" at http://php.net/manual/en/oci8.examples.php.

Additional we suggest to change the type of the row "content" from "VCHAR2" to "CLOB".

dregad

dregad

2012-08-07 10:47

developer   ~0032490

@CarstenGrohmann and @michalxo - I have logged 0014563 to track the ORA-01704 issue.

About changing the column type to CLOB, this needs to be carefully reviewed as the mantis data model must maintain compatibility with other DB types so we need to make sure that we use only data types supported by the ADOdb abstraction layer. I'll see what can be done about this.

@michalxo, you have not provided feedback on my question related to your first problem.

CarstenGrohmann

CarstenGrohmann

2012-08-08 01:46

reporter   ~0032495

May last comment contains a mistake. The colum "content" in the table "_bugfile" is a BLOB already. Thereby nothing need to change.

dregad

dregad

2012-11-16 03:49

developer   ~0034334

MantisBT release 1.2.12 has been merged into oracle branch - please download [1], test and provide your feedback here.

This updated branch includes fixes for a few issues, including 0014563 (ORA-01704 when attaching files with DB storage), 0012955 (encoding of BLOBs).

[1] https://github.com/dregad/mantisbt/archive/oracle-1.2.12.zip

adou

adou

2013-01-16 07:26

reporter   ~0034797

Last edited: 2013-01-23 11:31

View 2 revisions

I've tested MantisBT release 1.2.12 and I've an error when uploading a file:

#1465: ORA-01465: invalid hex number

INSERT INTO m_bug_file_t (bug_id, diskfile, filename, folder, filesize, file_type, date_added, content, user_id) values (:0, :1, :2, :3, :4, :5, :6, :7, :8)

Filename    Line            Function    Args
/var/www/mantisbt-oracle-1.2.12/core/database_api.php   446 -   -   trigger_error   ( <string>'401', <integer>256 )
/var/www/mantisbt-oracle-1.2.12/core/file_api.php   725 -   -   db_query_bound  ( <string>'INSERT INTO m_bug_file_t ( bug_id, title, description, diskfile, filename, folder, filesize, file_type, date_added, content, user_id ) VALUES ( :14, :15, :16, :17, :18, :19, :20, :21, :22, :23, :24 )', <Array> { [0] => 21947, [1] => '', [2] => '', [3] => 'aa4079b06b93dab55894e09c60bcd07c', [4] => 'bookmarks-2012-10-03.json', [5] => './archivos/', [6] => 11927, [7] => 'application/json', [8] => 1358337912, [9] => '\'\'', [10] => 21 } )
/var/www/mantisbt-oracle-1.2.12/bug_file_add.php    64  -   -   file_add    ( <integer>21947, <Array> { ['name'] => 'bookmarks-2012-10-03.json', ['tmp_name'] => '/tmp/phpdod49S', ['type'] => 'application/json', ['error'] => 0, ['size'] => 11927 }, <string>'bug' )
dregad

dregad

2013-04-24 04:34

developer   ~0036656

Release 1.2.15 has been merged into oracle branch [1] - please download and test !

Note that this a maintenance update to keep in sync with the latest MantisBT release.

[1] https://github.com/dregad/mantisbt/tree/oracle-1.2.15 [^]

miked1234

miked1234

2013-08-22 14:02

reporter   ~0037913

dregad - Have you figured out a resolution to the image upload when using Oracle? I get two errors.

When attempting to write to DISK, I get the below error; however, the image is actually written to the location specified.... just doesn't have a record in m_bug_file_t about it.

APPLICATION ERROR 0000401
Database query failed. Error received from database was #1465: ORA-01465: invalid hex number for the query: INSERT INTO m_bug_file_t (bug_id, diskfile, filename, folder, filesize, file_type, date_added, content, user_id) values (:0, :1, :2, :3, :4, :5, :6, :7, :8).

When I attempt to upload a file to database, I get the below error without a record being inserted into the m_bug_file_t table.

Database query failed. Error received from database was 0001461: ORA-01461: can bind a LONG value only for insert into a LONG column for the query: INSERT INTO m_bug_file_t (bug_id, diskfile, filename, filesize, file_type, date_added, content, user_id) values (:0, :1, :2, :3, :4, :5, :6, :7).

dregad

dregad

2013-08-24 19:40

developer   ~0037926

Hello, and thanks for the feedback.

I don't have access to an Oracle DB for testing purposes at the moment, so I can't be 100% sure, but the issue you describe should actually be fixed as part of 0014563 (to be released in MantisBT 1.2.16).

I suggest you try to apply the patch, let me know how it goes.

miked1234

miked1234

2013-08-26 10:56

reporter   ~0037928

Hmmmm I just changed my 'mod - core/file_api.php' file as suggested in the bottom of the ticket and it did not correct the issue. I don't see any other files that need to be changed on that ticket... When you say to apply the patch, were you referring to just this one file? If so, unfortunately the issue still occurs :/

dregad

dregad

2013-08-27 04:45

developer   ~0037930

Hi Mike

This commit was part of a branch I was working on about a year ago which I only recently merged it into core. I recall that back then I tested this successfully with Oracle (which I can't reproduce now since my test vm is dead). It is therefore possible that additional commits are needed to make this work.

What I just did for you is merge the 'file attach-fixes' branch into oracle, which should bring in all the required commits. Please try to download the updated code [1], test and let me know how it goes.

If the errors persist, it may be useful to provide me with additional debugging information (set $g_show_detailed_errors = ON; in your config_inc.php, save the output as HTML page and upload here - be careful to remove/mask any confidential information if needed)

[1] https://github.com/dregad/mantisbt/tree/oracle

miked1234

miked1234

2013-08-27 09:19

reporter   ~0037933

Thanks for the response, I appreciate your assistance as I evaluate Mantis- I used the code you suggested and there was no change in the errors- I've included two error pages. one is when attempting to write to disk, the other when attempting to write to the database.

Thanks!
MIke

miked1234

miked1234

2013-08-27 09:19

reporter  

Error_write_to_database.htm (206,755 bytes)
miked1234

miked1234

2013-08-27 09:20

reporter  

Error_write_to_disk.htm (6,461 bytes)
dregad

dregad

2013-08-27 19:38

developer   ~0037934

Last edited: 2013-08-27 19:47

View 2 revisions

I think I got it. In fact it appears to be a combination of several issues.

'ORA-01465: invalid hex number for the query' is caused by quoting the hex string corresponding to file contents, before executing the insert statement. This quoting is a leftover from executing SQL without bind variables. I'll commit a fix for that shortly.

After fixing this, another error pops up: 'ORA-01400: cannot insert NULL into ("MANTIS"."M_BUG_FILE_T"."CONTENT")' - I think this is due to incorrect default value for content column, I'll fix that too (see 0016331)

'ORA-01461: can bind a LONG value only for insert into a LONG column for the query' is more tricky, and caused by Oracle's handling of BLOB types which is quite different from other supported RDBMS. Fixing that will not be so easy.

I never noticed the 2nd issue, because I had been testing with small files, and the error only occurs when bind variable :7 (file contents) is > 4000 chars

So in summary, with the above-mentioned fixes you should be able to attach files to DISK successfully; attachment to DATABASE is limited to small files (about 2k) until I figure out a proper way to fix handling of BLOBs.

dregad

dregad

2013-08-28 17:48

developer   ~0037943

I believed I fixed both issues.

Limited testing (I put my Oracle DB config back up and running again while I was at it, too) shows that I can successfully upload both to disk and to DB.

Further feedback welcome.

CarstenGrohmann

CarstenGrohmann

2013-09-02 09:09

reporter   ~0037973

Last edited: 2013-09-02 09:17

View 3 revisions

Hi dregad,

I've tested the current version (2013-08-30 - 07264bd8398c36f2866a736076ce54faadc1e309) today. Our DBA created the schema and provided a admin user and an application user.

The database creation failed because with ORA-01031. The root cause is the statement "CREATE USER <database name> IDENTIFIED by xxx".

Please add an check to create the schema/database only, if it doesn't exists.

BTW: The option "Print SQL Queries instead of Writing to the Database" print all necessary database objects, but the output doesn't contains the "CREATE USER" statement. Thereby we need some time to identify the missing database permissions.

Thanks,
Carsten

dregad

dregad

2013-09-02 18:23

developer   ~0037979

Carsten, please follow up on this issue in 0016351

Related Changesets

MantisBT: master 2ce60e47

2011-08-10 12:34:07

dregad

Details Diff
Fix 0013227: Oracle database support (oci8)

Mantis 1.2.6 currently does not work with Oracle DB:
1. Installation:
1.1. Oracle DB autocreates PK, so index creation for same field forbidden
1.2. Oracle DB uses datetime literal format timestamp'YYYY-MM-DD HH-MI:SS'
1.3. Oracle DB don't allows altering field property NOT NULL into NOT NULL
1.4. Oracle DB max object length is 30 chars, so some index names must be reduced
1.5. Oracle DB means empty string as NULLs, so NOT NULL restriction must be disabled for some field
1.6. Oracle DB can resolve database server name through TNS, so database name cannot be required
2. General:
2.2. Direct DB query execution result accessing instead of db_fetch_array() 1.3. usage didn't works with Oracle DB
2.4. Oracle DB binds variable by name, so bind names in statement must be sorted to address them.
2.5. Oracle DB handles NULL/DEFAULT values with specific way.
2.6. Oracle DB returns NULL value as true PHP null
2.7. Oracle DB handles sequence access with specific syntax
2.8. Nothing returned by db_prepare_string() in case of oci8
2.9. Oracle DB max object length is 30 chars, so table names must be reduced
2.10. Oracle DB uses LOB literal format similar to mssql
2.11. GetRowAssoc returns empty field values with oci8, it's need to enable returning both associative and indexed arrays.

The original patch was provided by DKuranov. He reckons that this also resolves
issues 0006853, 0007644, 0010437, 0010996, 0011265, 0011270, 0011276, 0012152, 0012478

Porting to 1.3 - Conflicts:
admin/install.php
admin/schema.php
core/database_api.php
manage_tags_page.php
mod - admin/install.php Diff File
mod - admin/schema.php Diff File
mod - core/database_api.php Diff File

MantisBT: master a89e9c61

2011-08-10 13:32:40

dregad

Details Diff
Oracle support: revised schema.php to avoid schema version increase

Commit 9098615ccc028bee92c84e169353051b90aa1f20 introduced some schema changes
to fix Issues 0013227, which is not acceptable in a maintenance release. The
code was amended to avoid that.

Porting to 1.3 - Conflicts:
admin/schema.php
mod - admin/schema.php Diff File

MantisBT: master 5a84e9db

2011-08-11 11:25:58

dregad

Details Diff
Add new global config for plugin table prefix

This allows users on Oracle to shorten the table identifier, to avoid hitting
the 30-char size limit.

Also modified comments for the existing db prefix/suffix to explain that they
should be blank or shortened for Oracle.

Affects 0013227

Porting to 1.3 - Conflicts:
config_defaults_inc.php
core/plugin_api.php
mod - config_defaults_inc.php Diff File
mod - core/plugin_api.php Diff File

MantisBT: master 321e0356

2011-08-11 13:05:01

dregad

Details Diff
Align with coding standards

Renamed the new oracle-specific functions introduced to fix 0013227; implement
various minor changes to comply with coding standards (spaces/tabs, braces,
variable names...)
mod - core/database_api.php Diff File

MantisBT: master 803446e9

2011-09-02 05:58:25

dregad

Details Diff
Improve Oracle DB connection check in install.php

Oracle supports DB bindings in two ways:
1. Use hostname, username/password and database name
2. Use tns name (insert into hostname field) and username/password, database name is still empty

Original patch provided by Carsten Grohmann in issue 0013227

Porting to 1.3 - Conflicts:
admin/install.php
mod - admin/install.php Diff File

MantisBT: master f3df5f1c

2011-09-02 06:07:56

dregad

Details Diff
Modified generated SQL for triggers in install.php to work with Oracle sqlplus

"CREATE OR REPLACE TRIGGER" statements must end with
END;
/
to work for Oracle sqlplus

Original patch provided by Carsten Grohmann in issue 0013227

Porting to 1.3 - Conflicts:
admin/install.php
mod - admin/install.php Diff File

MantisBT: master 02bbb995

2013-08-27 18:46:44

dregad

Details Diff
file_add(): Oracle BLOB contents must not be quoted

Using a quoted hex string causes error 'ORA-01465: invalid hex number
for the query' when inserting the new record.

Follow-up fix for issue 0013227
mod - core/database_api.php Diff File
mod - core/file_api.php Diff File

MantisBT: master fd5d3712

2013-10-17 08:09:52

dregad

Details Diff
Fix Oracle support

This merges the master port of the original 'oracle' branch [1], which
was initially started for MantisBT 1.2.

It resolves a large number of issues related to Oracle compatibility and
support.

[1] https://github.com/dregad/mantisbt/tree/oracle

Fixes 0013227 (and many other related issues)
mod - admin/install.php Diff File
mod - admin/schema.php Diff File
mod - config_defaults_inc.php Diff File
mod - core/bug_api.php Diff File
mod - core/constant_inc.php Diff File
mod - core/database_api.php Diff File
mod - core/file_api.php Diff File
mod - core/helper_api.php Diff File
mod - core/plugin_api.php Diff File
mod - core/sponsorship_api.php Diff File
mod - lang/strings_english.txt Diff File

Issue History

Date Modified Username Field Change
2011-08-09 09:29 DKuranov New Issue
2011-08-09 09:30 DKuranov File Added: database_api.php
2011-08-09 09:31 DKuranov File Added: install.php
2011-08-09 09:31 DKuranov File Added: manage_tags_page.php
2011-08-09 09:31 DKuranov File Added: schema.php
2011-08-09 09:34 DKuranov Note Added: 0029411
2011-08-09 11:50 dregad Note Added: 0029415
2011-08-09 11:50 dregad Status new => acknowledged
2011-08-09 11:52 dregad Tag Attached: patch
2011-08-09 11:55 dregad Relationship added child of 0006853
2011-08-09 11:55 dregad Relationship added child of 0007644
2011-08-09 11:55 dregad Relationship added child of 0010437
2011-08-09 11:55 dregad Relationship added child of 0010996
2011-08-09 11:55 dregad Relationship added child of 0011265
2011-08-09 11:55 dregad Relationship added child of 0011270
2011-08-09 11:55 dregad Relationship added child of 0011276
2011-08-09 11:55 dregad Relationship added child of 0012152
2011-08-09 11:55 dregad Relationship added child of 0012478
2011-08-09 11:56 dregad Note Edited: 0029411 View Revisions
2011-08-10 04:17 DKuranov Note Added: 0029433
2011-08-10 12:36 dregad Note Added: 0029448
2011-08-10 12:57 dregad Note Added: 0029449
2011-08-10 13:06 dregad Assigned To => dregad
2011-08-10 13:06 dregad Status acknowledged => assigned
2011-08-10 13:26 DKuranov Note Added: 0029450
2011-08-10 13:54 dregad Note Added: 0029451
2011-08-11 01:57 DKuranov Note Added: 0029459
2011-08-11 13:38 dregad Note Added: 0029466
2011-08-17 01:31 DKuranov Note Added: 0029491
2011-08-28 14:56 CarstenGrohmann Note Added: 0029576
2011-08-28 19:09 dregad Relationship added related to 0013272
2011-08-29 07:32 CarstenGrohmann File Added: patch-hardcoded_table_name-20110829.diff
2011-08-29 07:33 CarstenGrohmann Note Edited: 0029576 View Revisions
2011-08-29 09:14 dregad Note Added: 0029591
2011-08-29 09:33 CarstenGrohmann File Added: patch-check_oracle_db_params-20110829.diff
2011-08-29 09:35 CarstenGrohmann Note Added: 0029593
2011-08-29 10:03 DKuranov Note Added: 0029594
2011-08-29 10:04 DKuranov Note Edited: 0029594 View Revisions
2011-08-29 10:19 CarstenGrohmann File Added: patch-check_oracle_db_params-20110829-2.diff
2011-08-29 10:56 CarstenGrohmann Note Edited: 0029593 View Revisions
2011-08-29 11:58 CarstenGrohmann Note Added: 0029596
2011-08-30 02:24 CarstenGrohmann File Added: patch-oracle_create_trigger-20110830.diff
2011-08-30 02:25 CarstenGrohmann Note Edited: 0029596 View Revisions
2011-08-30 07:57 CarstenGrohmann Note Added: 0029598
2011-09-02 06:16 dregad File Deleted: patch-check_oracle_db_params-20110829.diff
2011-09-02 06:23 dregad Note Added: 0029622
2011-09-02 06:24 dregad Note Edited: 0029622 View Revisions
2011-09-02 10:32 CarstenGrohmann Note Added: 0029627
2011-09-02 10:32 CarstenGrohmann Note View State: 0029627: private
2011-09-02 10:32 CarstenGrohmann Note View State: 0029627: public
2011-09-02 10:32 CarstenGrohmann Note Edited: 0029627 View Revisions
2011-09-02 10:32 CarstenGrohmann Note Edited: 0029627 View Revisions
2011-09-02 10:33 CarstenGrohmann Note Edited: 0029627 View Revisions
2011-09-02 10:42 CarstenGrohmann Note Added: 0029628
2011-09-02 12:04 dregad Note Added: 0029629
2011-09-02 12:31 dregad File Added: init-prefix-suffix.patch
2011-09-02 12:32 dregad Note Edited: 0029629 View Revisions
2011-09-02 12:38 CarstenGrohmann Note Added: 0029630
2011-09-09 12:28 dregad Relationship added parent of 0006895
2011-09-09 12:30 dregad Relationship added parent of 0008686
2011-09-09 12:31 dregad Relationship added related to 0010488
2011-09-09 12:37 dregad Relationship added parent of 0007185
2011-09-09 12:38 dregad Relationship added related to 0007190
2011-09-09 12:40 dregad Relationship added related to 0012151
2011-09-09 12:41 dregad Relationship added related to 0007179
2011-09-09 12:44 dregad Relationship added parent of 0007935
2011-09-09 12:44 dregad Relationship added parent of 0007246
2011-09-09 12:47 dregad Relationship added parent of 0007126
2011-10-21 07:35 adou Note Added: 0030017
2011-10-21 09:18 dregad Relationship added parent of 0013433
2011-10-21 09:18 dregad Note Added: 0030019
2011-10-25 13:21 dregad Note Added: 0030068
2012-03-12 08:48 dregad Note Added: 0031431
2012-04-13 08:35 adou Note Added: 0031651
2012-04-17 11:48 Karla Note Added: 0031675
2012-04-17 11:49 Karla Note Edited: 0031675 View Revisions
2012-04-17 11:52 Karla Note Added: 0031676
2012-04-18 03:57 dregad Note Added: 0031679
2012-04-18 04:05 dregad Note Added: 0031680
2012-04-18 04:09 dregad Note Edited: 0031431 View Revisions
2012-06-07 03:53 dregad Note Added: 0032031
2012-06-11 06:43 adou Note Added: 0032067
2012-06-11 07:07 dregad Note Added: 0032068
2012-07-05 10:04 dregad Note Edited: 0032068 View Revisions
2012-07-12 04:24 adou Note Added: 0032307
2012-07-12 18:31 dregad Note Added: 0032319
2012-07-16 03:58 michalxo Note Added: 0032342
2012-07-16 04:56 michalxo Note Edited: 0032342 View Revisions
2012-07-16 05:00 michalxo Note Edited: 0032342 View Revisions
2012-07-16 05:02 michalxo Note Edited: 0032342 View Revisions
2012-07-22 18:55 dregad Note Added: 0032356
2012-08-07 09:12 CarstenGrohmann Note Added: 0032489
2012-08-07 10:43 dregad Relationship added parent of 0014563
2012-08-07 10:47 dregad Note Added: 0032490
2012-08-08 01:46 CarstenGrohmann Note Added: 0032495
2012-11-16 03:49 dregad Note Added: 0034334
2012-12-19 19:42 dregad Relationship added related to 0011014
2013-01-16 07:26 adou Note Added: 0034797
2013-01-23 11:31 dregad Note Edited: 0034797 View Revisions
2013-01-25 10:39 dregad Relationship added parent of 0015426
2013-04-24 03:47 dregad Relationship added parent of 0012267
2013-04-24 04:34 dregad Note Added: 0036656
2013-08-22 14:02 miked1234 Note Added: 0037913
2013-08-24 19:40 dregad Note Added: 0037926
2013-08-26 10:56 miked1234 Note Added: 0037928
2013-08-27 04:45 dregad Note Added: 0037930
2013-08-27 05:57 dregad Relationship added parent of 0016330
2013-08-27 09:19 miked1234 Note Added: 0037933
2013-08-27 09:19 miked1234 File Added: Error_write_to_database.htm
2013-08-27 09:20 miked1234 File Added: Error_write_to_disk.htm
2013-08-27 19:38 dregad Note Added: 0037934
2013-08-27 19:47 dregad Relationship added parent of 0016331
2013-08-27 19:47 dregad Note Edited: 0037934 View Revisions
2013-08-28 10:55 dregad Relationship added parent of 0016336
2013-08-28 17:48 dregad Note Added: 0037943
2013-09-02 09:09 CarstenGrohmann Note Added: 0037973
2013-09-02 09:15 CarstenGrohmann Note Edited: 0037973 View Revisions
2013-09-02 09:17 CarstenGrohmann Note Edited: 0037973 View Revisions
2013-09-02 18:22 dregad Relationship added related to 0016351
2013-09-02 18:23 dregad Note Added: 0037979
2013-10-17 12:08 dregad Changeset attached => MantisBT master 2ce60e47
2013-10-17 12:08 dregad Changeset attached => MantisBT master a89e9c61
2013-10-17 12:08 dregad Changeset attached => MantisBT master 321e0356
2013-10-17 12:08 dregad Changeset attached => MantisBT master 803446e9
2013-10-17 12:08 dregad Changeset attached => MantisBT master f3df5f1c
2013-10-17 12:08 dregad Changeset attached => MantisBT master 02bbb995
2013-10-17 12:08 dregad Changeset attached => MantisBT master fd5d3712
2013-10-17 12:08 dregad Status assigned => resolved
2013-10-17 12:08 dregad Resolution open => fixed
2013-10-17 12:08 dregad Fixed in Version => 1.3.0-beta.1
2013-10-17 12:23 dregad Target Version => 1.3.0-beta.1
2014-01-13 19:47 dregad Relationship added has duplicate 0016832
2014-04-12 19:39 grangeway Issue cloned: 0017218
2014-05-19 07:48 dregad Changeset attached => MantisBT master 5a84e9db
2014-12-08 00:34 vboctor Status resolved => closed
2015-03-16 18:51 dregad Relationship replaced parent of 0010437
2015-03-16 19:18 dregad Relationship replaced parent of 0012152
2015-03-16 19:18 dregad Relationship replaced parent of 0011276
2015-03-16 19:18 dregad Relationship replaced parent of 0016351
2015-03-16 19:18 dregad Relationship replaced parent of 0012478
2015-03-16 19:19 dregad Relationship replaced parent of 0012151
2015-03-16 19:19 dregad Relationship replaced parent of 0011270
2015-03-16 19:19 dregad Relationship replaced parent of 0011265
2015-03-16 19:19 dregad Relationship replaced parent of 0011014
2015-03-16 19:20 dregad Relationship replaced parent of 0006853
2015-03-16 19:20 dregad Relationship replaced parent of 0010996
2015-03-16 19:23 dregad Relationship replaced parent of 0007644
2015-03-16 19:25 dregad Relationship replaced related to 0013433
2015-03-16 19:27 dregad Relationship added parent of 0010490